import { PublicKeyCredentialCreationOptionsJSON } from "@simplewebauthn/typescript-types";
import { HttpsFunction } from "firebase-functions";
import { FunctionResponseSuccessful } from "./function-response-successful";
import { FunctionResponseUnsuccessful } from "./function-response-unsuccessful";
interface CreateRegistrationChallengeFunctionResponseSuccessful extends FunctionResponseSuccessful {
    "creationOptions": PublicKeyCredentialCreationOptionsJSON;
}
interface CreateRegistrationChallengeFunctionResponseUnsuccessful extends FunctionResponseUnsuccessful {
    "message": "Please sign in anonymously first." | "A passkey already exists for this user.";
}
export interface CreateRegistrationChallengeFunctionRequest {
    "displayName": string;
}
export type CreateRegistrationChallengeFunctionResponse = CreateRegistrationChallengeFunctionResponseSuccessful | CreateRegistrationChallengeFunctionResponseUnsuccessful;
export declare const ngxFirebaseWebAuthnCreateRegistrationChallenge: HttpsFunction;
export {};
