"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ngxFirebaseWebAuthnCreateRegistrationChallenge = void 0;
const tslib_1 = require("tslib");
const server_1 = require("@simplewebauthn/server");
const auth_1 = require("firebase-admin/auth");
const firestore_1 = require("firebase-admin/firestore");
const firebase_functions_1 = require("firebase-functions");
exports.ngxFirebaseWebAuthnCreateRegistrationChallenge = (0, firebase_functions_1.runWith)({
    enforceAppCheck: true,
})
    .https
    .onCall((createRegistrationChallengeFunctionRequest, callableContext) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
    return callableContext.auth ? ((auth, firestore) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
        return ((userDocument) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
            return !(userDocument === null || userDocument === void 0 ? void 0 : userDocument.credentialPublicKey) ? ((publicKeyCredentialCreationOptions) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                return ((_writeResult) => ({
                    success: true,
                    creationOptions: publicKeyCredentialCreationOptions,
                }))(yield firestore.collection("ngxFirebaseWebAuthnUsers").doc(callableContext.auth.uid).set({
                    challenge: publicKeyCredentialCreationOptions.challenge,
                }));
            }))((0, server_1.generateRegistrationOptions)({
                authenticatorSelection: {
                    residentKey: "required",
                    userVerification: "required",
                },
                rpID: "console.gavinsawyer.dev",
                rpName: "GavinSawyer.dev Console",
                userID: callableContext.auth.uid,
                userName: createRegistrationChallengeFunctionRequest.displayName,
            })) : {
                success: false,
                message: "A passkey already exists for this user.",
            };
        }))((yield firestore.collection("ngxFirebaseWebAuthnUsers").doc(callableContext.auth.uid).get()).data());
    }))((0, auth_1.getAuth)(), (0, firestore_1.getFirestore)()) : {
        success: false,
        message: "Please sign in anonymously first.",
    };
}));
//# sourceMappingURL=create-registration-challenge-function.js.map