import { AuthenticationResponseJSON } from "@simplewebauthn/typescript-types";
import { HttpsFunction } from "firebase-functions";
import { FunctionResponseSuccessful } from "./function-response-successful";
import { FunctionResponseUnsuccessful } from "./function-response-unsuccessful";
interface VerifyAuthenticationFunctionResponseSuccessful extends FunctionResponseSuccessful {
    "customToken": string;
}
interface VerifyAuthenticationFunctionResponseUnsuccessful extends FunctionResponseUnsuccessful {
    "message": "A passkey doesn't exist for this user." | "Authentication response not verified." | "Please create an authentication challenge first." | "Please sign in anonymously first." | "The authenticator didn't provide a uid." | "This user doesn't exist." | "This user is already signed in.";
}
export interface VerifyAuthenticationFunctionRequest {
    "authenticationResponse": AuthenticationResponseJSON;
}
export type VerifyAuthenticationFunctionResponse = VerifyAuthenticationFunctionResponseSuccessful | VerifyAuthenticationFunctionResponseUnsuccessful;
export declare const ngxFirebaseWebAuthnVerifyAuthentication: HttpsFunction;
export {};
