"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ngxFirebaseWebAuthnVerifyAuthentication = void 0;
const tslib_1 = require("tslib");
const server_1 = require("@simplewebauthn/server");
const auth_1 = require("firebase-admin/auth");
const firestore_1 = require("firebase-admin/firestore");
const firebase_functions_1 = require("firebase-functions");
exports.ngxFirebaseWebAuthnVerifyAuthentication = (0, firebase_functions_1.runWith)({
    enforceAppCheck: true,
})
    .https
    .onCall((verifyAuthenticationFunctionRequest, callableContext) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
    return callableContext.auth ? ((auth, firestore) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
        return verifyAuthenticationFunctionRequest.authenticationResponse.response.userHandle !== callableContext.auth.uid ? ((userDocument) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
            return userDocument ? (() => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                return userDocument.credentialPublicKey ? ((anonymousUserDocument) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                    return anonymousUserDocument && anonymousUserDocument.challenge ? ((verifiedAuthenticationResponse) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                        return verifiedAuthenticationResponse.verified ? ((_writeResult) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                            return ((_writeResult) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                                return ((customToken) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                                    return ({
                                        success: true,
                                        customToken: customToken,
                                    });
                                }))(yield auth.createCustomToken(verifyAuthenticationFunctionRequest.authenticationResponse.response.userHandle));
                            }))(yield firestore.collection("ngxFirebaseWebAuthnUsers").doc(callableContext.auth.uid).delete());
                        }))(yield firestore.collection("ngxFirebaseWebAuthnUsers").doc(verifyAuthenticationFunctionRequest.authenticationResponse.response.userHandle).update({
                            challenge: firestore_1.FieldValue.delete(),
                            credentialCounter: verifiedAuthenticationResponse.authenticationInfo.newCounter,
                            credentialId: verifiedAuthenticationResponse.authenticationInfo.credentialID,
                        })) : ((_writeResult) => ({
                            success: false,
                            message: "Authentication response not verified.",
                        }))(yield firestore.collection("ngxFirebaseWebAuthnUsers").doc(callableContext.auth.uid).delete());
                    }))(yield (0, server_1.verifyAuthenticationResponse)({
                        authenticator: {
                            counter: userDocument.credentialCounter,
                            credentialID: userDocument.credentialId,
                            credentialPublicKey: userDocument.credentialPublicKey,
                        },
                        expectedChallenge: anonymousUserDocument.challenge,
                        expectedOrigin: "https://console.gavinsawyer.dev",
                        expectedRPID: "console.gavinsawyer.dev",
                        requireUserVerification: true,
                        response: verifyAuthenticationFunctionRequest.authenticationResponse,
                    })) : ((_writeResult) => ({
                        success: false,
                        message: "Please create an authentication challenge first.",
                    }))(yield firestore.collection("ngxFirebaseWebAuthnUsers").doc(callableContext.auth.uid).delete());
                }))((yield firestore.collection("ngxFirebaseWebAuthnUsers").doc(callableContext.auth.uid).get()).data()) : ((_writeResult) => ({
                    success: false,
                    message: "A passkey doesn't exist for this user.",
                }))(yield firestore.collection("ngxFirebaseWebAuthnUsers").doc(callableContext.auth.uid).delete());
            }))() : ((_writeResult) => ({
                success: false,
                message: "This user doesn't exist.",
            }))(yield firestore.collection("ngxFirebaseWebAuthnUsers").doc(callableContext.auth.uid).delete());
        }))((yield firestore.collection("ngxFirebaseWebAuthnUsers").doc(verifyAuthenticationFunctionRequest.authenticationResponse.response.userHandle).get()).data()) : ((_writeResult) => ({
            success: false,
            message: "This user is already signed in.",
        }))(yield firestore.collection("ngxFirebaseWebAuthnUsers").doc(callableContext.auth.uid).update({
            challenge: firestore_1.FieldValue.delete(),
        }));
    }))((0, auth_1.getAuth)(), (0, firestore_1.getFirestore)()) : {
        success: false,
        message: "Please sign in anonymously first."
    };
}));
//# sourceMappingURL=verify-authentication-function.js.map