"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ngxFirebaseWebAuthnVerifyRegistration = void 0;
const tslib_1 = require("tslib");
const server_1 = require("@simplewebauthn/server");
const auth_1 = require("firebase-admin/auth");
const firestore_1 = require("firebase-admin/firestore");
const firebase_functions_1 = require("firebase-functions");
exports.ngxFirebaseWebAuthnVerifyRegistration = (0, firebase_functions_1.runWith)({
    enforceAppCheck: true,
})
    .https
    .onCall((verifyRegistrationFunctionRequest, callableContext) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
    return callableContext.auth ? ((auth, firestore) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
        return ((userDocument) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
            return userDocument ? (() => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                return userDocument.challenge ? ((verifiedRegistrationResponse) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                    return verifiedRegistrationResponse.verified ? ((_writeResult) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                        return ((customToken) => ({
                            success: true,
                            customToken: customToken,
                        }))(yield auth.createCustomToken(callableContext.auth.uid));
                    }))(yield firestore.collection("ngxFirebaseWebAuthnUsers").doc(callableContext.auth.uid).update({
                        challenge: firestore_1.FieldValue.delete(),
                        credentialCounter: verifiedRegistrationResponse.registrationInfo.counter,
                        credentialId: verifiedRegistrationResponse.registrationInfo.credentialID,
                        credentialPublicKey: verifiedRegistrationResponse.registrationInfo.credentialPublicKey,
                    })) : ((_writeResult) => ({
                        success: false,
                        message: "Registration response not verified.",
                    }))(yield firestore.collection("ngxFirebaseWebAuthnUsers").doc(callableContext.auth.uid).delete());
                }))(yield (0, server_1.verifyRegistrationResponse)({
                    expectedChallenge: userDocument["challenge"],
                    expectedOrigin: "https://console.gavinsawyer.dev",
                    expectedRPID: "console.gavinsawyer.dev",
                    requireUserVerification: true,
                    response: verifyRegistrationFunctionRequest.registrationResponse,
                })) : ((_writeResult) => ({
                    success: false,
                    message: "Please create a registration challenge first.",
                }))(yield firestore.collection("ngxFirebaseWebAuthnUsers").doc(callableContext.auth.uid).delete());
            }))() : {
                success: false,
                message: "This user doesn't exist.",
            };
        }))((yield firestore.collection("ngxFirebaseWebAuthnUsers").doc(callableContext.auth.uid).get()).data());
    }))((0, auth_1.getAuth)(), (0, firestore_1.getFirestore)()) : {
        success: false,
        message: "Please sign in anonymously first.",
    };
}));
//# sourceMappingURL=verify-registration-function.js.map